\iffalse
This file is protected by Copyright. Please refer to the COPYRIGHT file
distributed with this source distribution.

This file is part of OpenCPI <http://www.opencpi.org>

OpenCPI is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

OpenCPI is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with this program. If not, see <http://www.gnu.org/licenses/>.
\fi

%----------------------------------------------------------------------------------------
% Required document specific properties
%----------------------------------------------------------------------------------------
\def\docTitle{E31x MIMO RCVR Filter Proxy Test App Guide}
% Assume this is in projects/osps/XXX of source checkout
\def\snippetpath{../../../../../../doc/av/tex/snippets}
%----------------------------------------------------------------------------------------
% Global latex header (this must be after document specific properties)
%----------------------------------------------------------------------------------------
\input{\snippetpath/LaTeX_Header}
\graphicspath{{figures/}}
%----------------------------------------------------------------------------------------

\begin{document}
\maketitle
\thispagestyle{empty}
\newpage

\begin{center}
  \textit{\textbf{Revision History}}
  \begin{table}[H]
    \label{table:revisions} % Add "[H]" to force placement of table
    \begin{tabularx}{\textwidth}{|c|X|l|}
      \hline
      \rowcolor{blue}
      \textbf{Revision} & \textbf{Description of Change} & \textbf{Date} \\
      \hline
      v1.4 & Initial release. & 9/2018 \\
      \hline
      v1.5 & Version bump only & 4/2019 \\
      \hline
    \end{tabularx}
  \end{table}
\end{center}
\newpage

\section{Description}
This application is intended to perform a hardware-in-the-loop test of the e31x\_{}mimo\_{}xcvr\_{}filter\_{}proxy.rcc device proxy.
The application is meant to exercise the properties of the proxy worker dynamically while the application is running. The different modes of the frontend are cycled through for various different frequency/filter bank settings to visually verify the LEDs are responding appropriately. The following steps are taken in the application:
\begin{itemize}
  \item[1.] Set the frequency of the RX and TX LOs
  \item[2.] Set the mode for Frontend A to TX,RX i.e. full duplex
  \item[3.] Set the mode for Frontend B to TX,RX i.e. full duplex
  \item[4.] Request user input for validation
  \item[5.] Set the mode for Frontend A to RX,off
  \item[6.] Set the mode for Frontend B to TX,RX i.e. full duplex
  \item[7.] Request user input for validation
  \item[8.] Set the mode for Frontend A to RX,off
  \item[9.] Set the mode for Frontend B to RX,off
  \item[10.] Request user input for validation
  \item[11.] Set the mode for Frontend A to TX,RX i.e. full duplex
  \item[12.] Set the mode for Frontend B to RX,off
  \item[13.] Request user input for validation
  \item[14.] Set the mode for Frontend A to TX,RX i.e. full duplex
  \item[15.] Set the mode for Frontend B to off,off
  \item[16.] Request user input for validation
  \item[17.] Set the mode for Frontend A to off,off
  \item[18.] Set the mode for Frontend B to TX,RX i.e. full duplex
  \item[19.] Request user input for validation
  \item[20.] Set the mode for Frontend A to off,off
  \item[21.] Set the mode for Frontend B to off,off
  \item[22.] Request user input for validation
  \item[23.] Repeat steps 1 through 22 for each frequency being tested
\end{itemize}

\section{Hardware Portability}
This application is intended to test e31x\_{}mimo\_{}filter\_{}proxy.rcc, which is by design specific to the \verb+e31x+ platform.

\section{Execution}
\subsection{Prerequisites}
The following must be true before application execution:
\begin{itemize}
  \item The following assets are built and their build artifacts (FPGA bitstream file/shared object file) are contained within the directory list of the OCPI\_{}LIBRARY\_{}PATH environment variable.
  \begin{itemize}
    \item for \verb+e31x+/\verb+xilinx13_4+ HDL/RCC platforms:
    \begin{itemize}
      \item \verb+empty+/\verb+cnt_e31x_mimo_xcvr_filter+ assembly/container
      \item \verb+e31x_mimo_xcvr_filter_proxy.rcc+
    \end{itemize}
  \end{itemize}
\item The current directory is the applications/e31x\_{}mimo\_{}xcvr\_{}filter\_{}proxy\_{}test directory.
\end{itemize}
\subsection{Command(s)}
\lstset{language=bash, backgroundcolor=\color{lightgray}, columns=flexible, breaklines=true, prebreak=\textbackslash, basicstyle=\ttfamily, showstringspaces=false,upquote=true, aboveskip=\baselineskip, belowskip=\baselineskip}
\begin{lstlisting}
./<target-dir>/e31x_mimo_xcvr_filter_proxy_test
\end{lstlisting}

\section{Verification}
Verification is performed by running the application and visually verifying that the LEDs on the E31x match the values printed to stdout. An application exit status which is non-zero indicates that the test could not complete.

\end{document}
